#cs===============================================
	World of Goo Portable Launcher
	By GMMan
	Version 0.2 Beta
	December 5, 2009
	(C)2009 GMMan and GMWare. All rights reserved.
	Distributed under the Creative Commons Attribution-Share Alike 2.5 Canada License
#ce===============================================

#NoTrayIcon
#Region ;**** Directives created by AutoIt3Wrapper_GUI ****
#AutoIt3Wrapper_Icon=cfg\WorldOfGoo.ico
#AutoIt3Wrapper_Outfile=build\WorldOfGooPortable.exe
#AutoIt3Wrapper_Compression=4
#AutoIt3Wrapper_Res_Description=World of Goo Portable
#AutoIt3Wrapper_Res_Fileversion=0.2 Beta
#AutoIt3Wrapper_Res_LegalCopyright=2009 GMMan and GMWare. All Rights Reserved.
#AutoIt3Wrapper_Res_Language=1033
#AutoIt3Wrapper_Res_Field=Author|GMMan
#AutoIt3Wrapper_Res_Field=CompanyName|GMWare
#AutoIt3Wrapper_Res_Field=InternalName|WoGPortable
#AutoIt3Wrapper_Res_Field=OriginalFilename|WorldOfGooPortable.exe
#AutoIt3Wrapper_Res_Field=ProductName|World of Goo Portable
#AutoIt3Wrapper_Run_Tidy=y
#EndRegion ;**** Directives created by AutoIt3Wrapper_GUI ****

;===Start Include===
#include <ButtonConstants.au3>
#include <EditConstants.au3>
#include <GUIConstantsEx.au3>
#include <StaticConstants.au3>
#include <WindowsConstants.au3>
;===End Include===

;===Start Variable Declaration===
Dim $cfgPath = @ScriptDir & "\cfg\wogportable.ini"
Dim $defaultWoGInstallPath[2] = [@ProgramFilesDir & "\WorldOfGoo\", @ProgramFilesDir & "\WorldOfGooDemo\"]
Dim $defaultWoGInstallPathx64[2] = [EnvGet("PROGRAMFILES(X86)") & "\WorldOfGoo\", EnvGet("PROGRAMFILES(X86)") & "\WorldOfGooDemo\"]
Dim $defaultGooToolInstallPath = @ProgramFilesDir & "\GooTool\"
Dim $defaultGooToolInstallPathx64 = EnvGet("PROGRAMFILES(X86)") & "\GooTool\"
Dim $2DBoyProfilePathFull = RegRead("HKCU\Software\Microsoft\Windows\CurrentVersion\Explorer\Shell Folders", "Local AppData") & "\2DBoy\"
Dim $2DBoyProfilePathDemoAllUsers = @AppDataCommonDir & "\2DBoy\"
Dim $2DBoyProfilePathDemoPersonal = @AppDataDir & "\2DBoy\"
Dim $WoGProfileFolder = "WorldOfGoo\"
Dim $profileExists = 0
Dim $copyError = 0
Dim $version = "0.2 Beta"
Dim $usingMainGUIGooTool = 0
;===End Variable Declaration===

;===Start Loading Config===
If FileExists($cfgPath) Then
	Dim $WoGAppPath = @ScriptDir & IniRead($cfgPath, "Main", "appPath", "\app\WorldOfGoo\")
	Dim $GooToolAppPath = @ScriptDir & IniRead($cfgPath, "Main", "gooToolPath", "\app\GooTool\")
	Dim $WoGModdedAppPath = @ScriptDir & IniRead($cfgPath, "Main", "appModdedPath", "\app\WoGModded\")

	Dim $launchAutoTimeout = IniRead($cfgPath, "Main", "autolaunch", 0)
	Dim $autoLaunchCountdown = $launchAutoTimeout
	Dim $WoGType = IniRead($cfgPath, "Main", "WoGType", "auto")
	Dim $portableProfilePath = @ScriptDir & IniRead($cfgPath, "Main", "dataPath", "\data\")
	Dim $dontCopyGooTool = IniRead($cfgPath, "Main", "dontCopyGooTool", 0)

	Dim $WoGDemoURL = IniRead($cfgPath, "URLs", "demoURL", "http://www.worldofgoo.com/dl2.php?lk=demo")
	Dim $WoGPatchURL = IniRead($cfgPath, "URLs", "WoGPatchURL", "http://www.worldofgoo.com/dl2.php?lk=patch")
	Dim $twodBoyURL = IniRead($cfgPath, "URLs", "twodBoyURL", "http://www.2dboy.com/")
	Dim $WoGSoundtrackURL = IniRead($cfgPath, "URLs", "WoGSoundtrackURL", "http://kylegabler.com/WorldOfGooSoundtrack/")
	Dim $gooFansURL = IniRead($cfgPath, "URLs", "gooFansURL", "http://www.goofans.com/")
	Dim $kyleGablerURL = IniRead($cfgPath, "URLs", "kyleGablerURL", "http://www.kylegabler.com/")
	Dim $twodBoyForumURL = IniRead($cfgPath, "URLs", "twodBoyForumURL", "http://2dboy.com/forum/")
	Dim $experimentalGameplayURL = IniRead($cfgPath, "URLs", "experimentalGameplayURL", "http://www.experimentalgameplay.com/")
	Dim $WoGWikiURL = IniRead($cfgPath, "URLs", "WoGWikiURL", "http://worldofgoo.wikia.com/wiki/Main_Page")
	Dim $gooToolURL = IniRead($cfgPath, "URLs", "gooToolURL", "http://goofans.com/download/utility/gootool")
Else
	;Error message if config not found
	MsgBox(0x1030, "World of Goo Portable", "I can't find the config file. Maybe your computer ate it. --The Confused Sign Painter" & _
			@LF & @LF & "Please reextract the config file from the original archive.")
	Exit (1)
EndIf
;===End Loading Config===


;===Start Copying Processes===
;Check for existence of World of Goo in the WoG Portable folder
If FileExists($WoGAppPath & "WorldOfGoo.exe") == 0 Then
	;Architecture check
	If EnvGet("PROGRAMFILES(X86)") <> "" Then
		If FileExists($defaultWoGInstallPathx64[0] & "WorldOfGoo.exe") Then
			$copyError = copyWoG($defaultWoGInstallPathx64[0], "World of Goo", 0)
			;Also checks for demo
		ElseIf FileExists($defaultWoGInstallPathx64[1] & "WorldOfGoo.exe") Then
			$copyError = copyWoG($defaultWoGInstallPathx64[1], "World of Goo", 0)
		Else
			$copyError = 1
		EndIf
	Else
		If FileExists($defaultWoGInstallPath[0] & "WorldOfGoo.exe") Then
			$copyError = copyWoG($defaultWoGInstallPath[0], "World of Goo", 0)
			;Also checks for demo
		ElseIf FileExists($defaultWoGInstallPath[1] & "WorldOfGoo.exe") Then
			$copyError = copyWoG($defaultWoGInstallPath[1], "World of Goo", 0)
		Else
			$copyError = 1
		EndIf
	EndIf
EndIf
checkCopyError("World of Goo")

;Check for existence of GooTool in the WoG Portable folder
If gooToolCopied() == 0 And FileExists($WoGAppPath & "WorldOfGoo.exe") And $dontCopyGooTool == 0 Then
	;Architecture check
	If EnvGet("PROGRAMFILES(X86)") <> "" Then
		If FileExists($defaultGooToolInstallPathx64 & "bin\gootool.exe") Then
			$copyError = copyWoG($defaultGooToolInstallPathx64, "GooTool", 0)
		Else
			$copyError = 1
		EndIf
	Else
		If FileExists($defaultGooToolInstallPath & "bin\gootool.exe") Then
			$copyError = copyWoG($defaultGooToolInstallPath, "GooTool", 0)
		Else
			$copyError = 1
		EndIf
	EndIf
EndIf

Func gooToolCopied()
	Return FileExists($GooToolAppPath & "\bin\gootool.exe")
EndFunc   ;==>gooToolCopied

Func checkCopyError($copyType)
	;If there is a copying error, presume source not found and present source selection GUI
	If $copyType == "World of Goo" Then
		If EnvGet("PROGRAMFILES(X86)") <> "" Then
			Dim $browseWoGFolder = $defaultWoGInstallPathx64[0]
		Else
			Dim $browseWoGFolder = $defaultWoGInstallPath[0]
		EndIf
	ElseIf $copyType == "GooTool" Then
		If EnvGet("PROGRAMFILES(X86)") <> "" Then
			Dim $browseWoGFolder = $defaultGooToolInstallPathx64
		Else
			Dim $browseWoGFolder = $defaultGooToolInstallPath
		EndIf
	EndIf

	If $copyError Then
		#Region ### START Koda GUI section ### Form=d:\documents and settings\yukai\desktop\wogportable\cantfindform.kxf
		$cantFindForm = GUICreate("World of Goo Portable", 491, 113, -1, -1, BitOR($WS_SYSMENU, $WS_CAPTION, $WS_POPUP, $WS_POPUPWINDOW, $WS_BORDER, $WS_CLIPSIBLINGS), BitOR($WS_EX_APPWINDOW, $WS_EX_WINDOWEDGE))
		$excIcon = GUICtrlCreateIcon(@SystemDir & "\user32.dll", -2, 16, 24, 32, 32, BitOR($SS_NOTIFY, $WS_GROUP))
		$cantFindLabel = GUICtrlCreateLabel("I can't find " & $copyType & ". Could you help me find it? --The Lost Sign Painter", 64, 24, 357, 17)
		$WoGLocationInput = GUICtrlCreateInput($browseWoGFolder, 64, 48, 337, 21)
		$browseButton = GUICtrlCreateButton("Browse...", 408, 46, 75, 25, $WS_GROUP)
		$OKButton = GUICtrlCreateButton("OK", 328, 80, 75, 25, $WS_GROUP)
		$cancelButton = GUICtrlCreateButton("Cancel", 408, 80, 75, 25, $WS_GROUP)
		GUISetState(@SW_SHOW)
		#EndRegion ### END Koda GUI section ###

		While 1
			$nMsg = GUIGetMsg()
			Switch $nMsg
				Case $GUI_EVENT_CLOSE
					GUIDelete($cantFindForm)
					If $copyType == "GooTool" Then
						dispNotInstalledGooTool()
					Else
						dispNotInstalled()
						Exit (1)
					EndIf
					ExitLoop
				Case $browseButton
					$browseWoGFolder = FileSelectFolder("Please select where you installed " & $copyType & ".", "")
					If $browseWoGFolder Then
						GUICtrlSetData($WoGLocationInput, $browseWoGFolder)
					EndIf
				Case $OKButton
					$browseWoGFolder = GUICtrlRead($WoGLocationInput)
					GUIDelete($cantFindForm)
					$copyError = copyWoG($browseWoGFolder, $copyType, 1)
					If $copyType == "GooTool" And $copyError == 2 Then
						dispNotInstalledGooTool()
					ElseIf $copyError == 2 Then
						dispNotInstalled()
						Exit (1)
					EndIf
					ExitLoop
				Case $cancelButton
					GUIDelete($cantFindForm)
					If $copyType == "GooTool" Then
						dispNotInstalledGooTool()
					Else
						dispNotInstalled()
						Exit (1)
					EndIf
					ExitLoop
			EndSwitch
		WEnd
	EndIf
	$copyError = 0
EndFunc   ;==>checkCopyError

;Error message if copying was not successful after selecting source
Func dispNotInstalled()
	$msgReply = MsgBox(0x1111, "World of Goo Portable", "I still can't find World of Goo. Maybe you didn't install it? --The Disappointed Sign Painter" & _
			@LF & @LF & "If you haven't yet installed World of Goo, please install it." & @LF & "You can download a demo at " & $WoGDemoURL & ".")
	;If OK was pressed, open the demo download page in default browser
	If $msgReply == 1 Then
		ShellExecute($WoGDemoURL)
	EndIf
EndFunc   ;==>dispNotInstalled

Func dispNotInstalledGooTool()
	$msgReply = MsgBox(0x1111, "World of Goo Portable", "I still can't find GooTool. Maybe you didn't install it? --The Disappointed Sign Painter" & _
			@LF & @LF & "If you haven't yet installed GooTool, please install it." & @LF & "You can download it at " & $gooToolURL & ".")
	;If OK was pressed, open the demo download page in default browser
	If $msgReply == 1 Then
		ShellExecute($gooToolURL)
	EndIf
EndFunc   ;==>dispNotInstalledGooTool

;Main World of Goo copying function
Func copyWoG($path, $copyType, $failType)
	;===Start Variable Declaration===
	Dim $dirCopyError = 0
	Dim $msgReply
	Dim $returnValue
	;===End Variable Declaration===

	;Create Copying GUI
	#Region ### START Koda GUI section ### Form=D:\Documents and Settings\Yukai\Desktop\wogportable\copyingForm.kxf
	$copyingForm = GUICreate("World of Goo Portable", 412, 73, -1, -1, BitOR($WS_DLGFRAME, $WS_CLIPSIBLINGS), BitOR($WS_EX_APPWINDOW, $WS_EX_WINDOWEDGE))
	$infoIcon = GUICtrlCreateIcon(@SystemDir & "\user32.dll", -5, 8, 8, 32, 32, BitOR($SS_NOTIFY, $WS_GROUP))
	$copyingLabel = GUICtrlCreateLabel("Please wait... " & $copyType & " is being copied into your WoG Portable folder.", 48, 16, 352, 17)
	GUISetState(@SW_SHOW)
	#EndRegion ### END Koda GUI section ###
	;Attempt copying
	If $copyType == "World of Goo" Then
		$dirCopyError = DirCopy($path, $WoGAppPath, 1)
	ElseIf $copyType == "GooTool" Then
		$dirCopyError = DirCopy($path, $GooToolAppPath, 1)
	EndIf
	GUIDelete()
	;Success message
	If $dirCopyError Then
		If $copyType == "World of Goo" Then
			MsgBox(0x40, "World of Goo Portable", "Copy Successful!", 5)
		ElseIf $copyType == "GooTool" Then
			MsgBox(0x40, "World of Goo Portable", "Copy Successful! To install a modded World of Goo for World of Goo Portable, please set your Custom World of Goo Location in GooTool to:" & _
					@LF & $WoGModdedAppPath)
		EndIf
		$returnValue = 0
	Else
		;Failure message
		$msgReply = MsgBox(0x35, "World of Goo Portable", "Can't copy " & $copyType & ". Make sure destination is not read-only.")
		Switch $msgReply
			Case 4
				;Try again
				#Region ### START Koda GUI section ### Form=D:\Documents and Settings\Yukai\Desktop\wogportable\copyingForm.kxf
				$copyingForm = GUICreate("World of Goo Portable", 412, 73, -1, -1, BitOR($WS_DLGFRAME, $WS_CLIPSIBLINGS), BitOR($WS_EX_APPWINDOW, $WS_EX_WINDOWEDGE))
				$infoIcon = GUICtrlCreateIcon(@SystemDir & "\user32.dll", -5, 8, 8, 32, 32, BitOR($SS_NOTIFY, $WS_GROUP))
				$copyingLabel = GUICtrlCreateLabel("Please wait... " & $copyType & " is being copied into your WoG Portable folder.", 48, 16, 352, 17)
				GUISetState(@SW_SHOW)
				#EndRegion ### END Koda GUI section ###
				If $copyType == "World of Goo" Then
					$dirCopyError = DirCopy($path, $WoGAppPath, 1)
				ElseIf $copyType == "GooTool" Then
					$dirCopyError = DirCopy($path, $GooToolAppPath, 1)
				EndIf
				GUIDelete()
				;Success message
				If $dirCopyError Then
					If $copyType == "World of Goo" Then
						MsgBox(0x40, "World of Goo Portable", "Copy Successful!", 5)
					ElseIf $copyType == "GooTool" Then
						MsgBox(0x40, "World of Goo Portable", "Copy Successful! To install a modded World of Goo for World of Goo Portable, please set your Custom World of Goo Location in GooTool to:" & _
								@LF & $WoGModdedAppPath)
					EndIf
					$returnValue = 0
				Else
					;Still fail, return failure value
					If $failType == 0 Then
						$returnValue = 1
					Else
						$returnValue = 2
					EndIf
				EndIf
			Case 2
				;Cancel; return failure value
				If $failType == 0 Then
					$returnValue = 1
				Else
					$returnValue = 2
				EndIf
		EndSwitch
	EndIf
	Return ($returnValue)
EndFunc   ;==>copyWoG
;===End Copying Processes===


;===Start Main GUI===
If gooToolCopied() And FileExists($WoGAppPath & "WorldOfGoo.exe") Then
	openMainGUIGooTool()
ElseIf FileExists($WoGAppPath & "WorldOfGoo.exe") Then
	#Region ### START Koda GUI section ### Form=d:\documents and settings\yukai\desktop\wogportable\mainguiform.kxf
	$mainGUIForm = GUICreate("World of Goo Portable", 394, 241, -1, -1)
	$WoGBanner = GUICtrlCreatePic(@ScriptDir & "\cfg\wogDlBanner1.bmp", 0, 0, 394, 150, BitOR($SS_NOTIFY, $WS_GROUP, $WS_CLIPSIBLINGS))
	$playButton = GUICtrlCreateButton("Play", 8, 160, 187, 41, $WS_GROUP)
	$profilesButton = GUICtrlCreateButton("Profile", 200, 160, 183, 41, $WS_GROUP)
	$optionsButton = GUICtrlCreateButton("Options", 8, 208, 113, 25, $WS_GROUP)
	$exitButton = GUICtrlCreateButton("Exit", 272, 208, 113, 25, $WS_GROUP)
	$onlineButton = GUICtrlCreateButton("Information Superhighway", 128, 208, 139, 25, $WS_GROUP)
	GUISetState(@SW_SHOW)
	#EndRegion ### END Koda GUI section ###

	While 1
		$nMsg = GUIGetMsg()
		#cs If $autoLaunchCountdown > 0 Then
			Sleep(1000)
			$autoLaunchCountdown -= 1
			GUICtrlSetData($playButton, "Play(" & $autoLaunchCountdown & ")")
			If $autoLaunchCountdown == 0 Then
			$nMsg = $playButton
			EndIf
		#ce EndIf
		Switch $nMsg
			Case $GUI_EVENT_CLOSE
				Exit
			Case $playButton
				GUIDelete()
				launchWoG("World of Goo")
				ExitLoop
			Case $profilesButton
				openProfilesGUI()
			Case $optionsButton
				openOptionsGUI()
			Case $exitButton
				Exit
			Case $onlineButton
				openOnlineGUI()
		EndSwitch
	WEnd
EndIf
;===End Main GUI===

Func openMainGUIGooTool()
	$usingMainGUIGooTool = 1

	#Region ### START Koda GUI section ### Form=D:\Documents and Settings\Yukai\Desktop\wogportable\mainGUIGooToolForm.kxf
	$mainGUIGooToolForm = GUICreate("World of Goo Portable", 394, 290, -1, -1)
	$WoGBanner = GUICtrlCreatePic(@ScriptDir & "\cfg\wogDlBanner1.bmp", 0, 0, 394, 150, BitOR($SS_NOTIFY, $WS_GROUP, $WS_CLIPSIBLINGS))
	$playButton = GUICtrlCreateButton("Play", 8, 160, 187, 41, $WS_GROUP)
	$profilesButton = GUICtrlCreateButton("Profile", 200, 208, 183, 41, $WS_GROUP)
	$optionsButton = GUICtrlCreateButton("Options", 8, 256, 113, 25, $WS_GROUP)
	$exitButton = GUICtrlCreateButton("Exit", 272, 256, 113, 25, $WS_GROUP)
	$onlineButton = GUICtrlCreateButton("Information Superhighway", 128, 256, 139, 25, $WS_GROUP)
	$playModdedButton = GUICtrlCreateButton("Play Modded", 8, 208, 187, 41, $WS_GROUP)
	$launchGooToolButton = GUICtrlCreateButton("Launch GooTool", 200, 160, 183, 41, $WS_GROUP)
	GUISetState(@SW_SHOW)
	#EndRegion ### END Koda GUI section ###

	While 1
		$nMsg = GUIGetMsg()
		Switch $nMsg
			Case $GUI_EVENT_CLOSE
				Exit
			Case $playButton
				GUIDelete()
				launchWoG("World of Goo")
				ExitLoop
			Case $profilesButton
				openProfilesGUI()
			Case $optionsButton
				openOptionsGUI()
			Case $exitButton
				Exit
			Case $onlineButton
				openOnlineGUI()
			Case $playModdedButton
				If FileExists($WoGModdedAppPath & "WorldOfGoo.exe") Then
					GUIDelete()
					launchWoG("World of Goo Modded")
					ExitLoop
				Else
					MsgBox(0x40, "World of Goo Portable", "A modded version of World of Goo is not found. Please set your Custom World of Goo Location in GooTool to:" & _
							@LF & $WoGModdedAppPath)
				EndIf
			Case $launchGooToolButton
				GUIDelete()
				launchWoG("GooTool")
				ExitLoop
		EndSwitch
	WEnd
EndFunc   ;==>openMainGUIGooTool

;World of Goo Launch Function
Func launchWoG($launchType)
	;Detect if World of Goo is full or demo
	If $WoGType == "auto" Then
		If FileExists($WoGAppPath & "res\levels\ObservatoryObservationStation\ObservatoryObservationStation.level.bin") Then
			$WoGType = "full"
		Else
			$WoGType = "demo"
		EndIf
	EndIf

	If FileExists($portableProfilePath & "pers2.dat") Then
		If $WoGType == "full" Then
			If FileExists($2DBoyProfilePathFull & $WoGProfileFolder & "pers2.dat") Then
				FileMove($2DBoyProfilePathFull & $WoGProfileFolder & "pers2.dat", $2DBoyProfilePathFull & $WoGProfileFolder & "_pers2.dat", 1)
				$profileExists = 1
			EndIf
			copyProfile($portableProfilePath, $2DBoyProfilePathFull & $WoGProfileFolder)
		Else
			If FileExists($2DBoyProfilePathDemoAllUsers & $WoGProfileFolder & "pers2.dat") Then
				FileMove($2DBoyProfilePathDemoAllUsers & $WoGProfileFolder & "pers2.dat", $2DBoyProfilePathDemoAllUsers & $WoGProfileFolder & "_pers2.dat", 1)
				$profileExists = 2
			EndIf
			$copyError = copyProfile($portableProfilePath, $2DBoyProfilePathDemoAllUsers & $WoGProfileFolder)
			If $copyError Then
				If FileExists($2DBoyProfilePathDemoPersonal & $WoGProfileFolder & "pers2.dat") Then
					FileMove($2DBoyProfilePathDemoPersonal & $WoGProfileFolder & "pers2.dat", $2DBoyProfilePathDemoPersonal & $WoGProfileFolder & "_pers2.dat", 1)
					$profileExists = 3
				EndIf
				$copyError = copyProfile($portableProfilePath, $2DBoyProfilePathDemoPersonal & $WoGProfileFolder)
			EndIf
		EndIf
	EndIf
	If $launchType == "World of Goo" Then
		ShellExecuteWait($WoGAppPath & "WorldOfGoo.exe", "", $WoGAppPath)
	ElseIf $launchType == "World of Goo Modded" Then
		ShellExecuteWait($WoGModdedAppPath & "WorldOfGoo.exe", "", $WoGModdedAppPath)
	ElseIf $launchType == "GooTool" Then
		ShellExecuteWait($GooToolAppPath & "bin\gootool.exe", "-preferences """ & $portableProfilePath & "gootool.cfg""", $GooToolAppPath)
		ProcessWaitClose("gootool.exe")
	EndIf
	cleanupProfile()
EndFunc   ;==>launchWoG

;World of Goo Profile Copy Function
Func copyProfile($source, $dest)
	$erroro = FileCopy($source & "pers2.dat", $dest & "pers2.dat", 9)
	If $erroro == 0 Then
		Return (1)
	Else
		Return (0)
	EndIf
EndFunc   ;==>copyProfile

;World of Goo Portable Cleanup Function
Func cleanupProfile()
	If $WoGType == "full" Then
		$copyError = copyProfile($2DBoyProfilePathFull & $WoGProfileFolder, $portableProfilePath)
		If $copyError Then
			copyProfileFail($2DBoyProfilePathFull & $WoGProfileFolder & "pers2.dat", 1)
		EndIf
	Else
		$copyError = copyProfile($2DBoyProfilePathDemoPersonal & $WoGProfileFolder, $portableProfilePath)
		If $copyError Then
			$copyError = copyProfile($2DBoyProfilePathDemoAllUsers & $WoGProfileFolder, $portableProfilePath)
			If $copyError Then
				copyProfileFail("demo", 1)
			EndIf
		EndIf
	EndIf

	If $profileExists == 1 Then
		$copyError = FileMove($2DBoyProfilePathFull & $WoGProfileFolder & "_pers2.dat", $2DBoyProfilePathFull & $WoGProfileFolder & "pers2.dat", 1)
		If Not $copyError Then
			copyProfileFail($2DBoyProfilePathFull & $WoGProfileFolder, 2)
		EndIf
	ElseIf $profileExists == 2 Then
		$copyError = FileMove($2DBoyProfilePathDemoAllUsers & $WoGProfileFolder & "_pers2.dat", $2DBoyProfilePathDemoAllUsers & $WoGProfileFolder & "pers2.dat", 1)
		If Not $copyError Then
			copyProfileFail($2DBoyProfilePathDemoAllUsers & $WoGProfileFolder, 2)
		EndIf
	ElseIf $profileExists == 3 Then
		$copyError = FileMove($2DBoyProfilePathDemoPersonal & $WoGProfileFolder & "_pers2.dat", $2DBoyProfilePathDemoPersonal & $WoGProfileFolder & "pers2.dat", 1)
		If Not $copyError Then
			copyProfileFail($2DBoyProfilePathDemoPersonal & $WoGProfileFolder, 2)
		EndIf
	Else
		If $WoGType == "full" Then
			DirRemove($2DBoyProfilePathFull & $WoGProfileFolder)
		Else
			DirRemove($2DBoyProfilePathDemoAllUsers & $WoGProfileFolder)
			DirRemove($2DBoyProfilePathDemoPersonal & $WoGProfileFolder)
		EndIf
	EndIf
	Exit (0)
EndFunc   ;==>cleanupProfile

Func copyProfileFail($badness, $mode)
	If $mode == 1 Then
		If $badness == "demo" Then
			MsgBox(0x30, "World of Goo Portable", "Profile copy unsuccessful. Please manually copy" & _
					@LF & $2DBoyProfilePathDemoPersonal & $WoGProfileFolder & "pers2.dat or" & _
					@LF & $2DBoyProfilePathDemoAllUsers & $WoGProfileFolder & "pers2.dat to" & _
					@LF & $portableProfilePath & "pers2.dat.")
		Else
			MsgBox(0x30, "World of Goo Portable", "Profile copy unsuccessful. Please manually copy" & _
					@LF & $badness & "pers2.dat to" & _
					@LF & $portableProfilePath & "pers2.dat.")
		EndIf
		Exit (2)
	ElseIf $mode == 2 Then
		MsgBox(0x30, "World of Goo Portable", "Original profile restore unsuccessful. Please manually rename" & _
				@LF & $badness & "_pers2.dat to" & _
				@LF & $badness & "pers2.dat.")
		Exit (3)
	EndIf
EndFunc   ;==>copyProfileFail

;Profiles GUI
Func openProfilesGUI()
	#Region ### START Koda GUI section ### Form=d:\documents and settings\yukai\desktop\wogportable\profileform.kxf
	$profileForm = GUICreate("Profile Management", 330, 531, -1, -1, BitOR($WS_SYSMENU, $WS_CAPTION, $WS_POPUP, $WS_POPUPWINDOW, $WS_BORDER, $WS_CLIPSIBLINGS))
	$importGroup = GUICtrlCreateGroup("Import", 8, 8, 313, 97)
	$fullToPortableButton = GUICtrlCreateButton("Full to Portable", 16, 24, 297, 25, $WS_GROUP)
	$demoAllUsersToPortableButton = GUICtrlCreateButton("Demo Public to Portable", 16, 48, 297, 25, $WS_GROUP)
	$demoPersonalToPortableButton = GUICtrlCreateButton("Demo Private to Portable", 16, 72, 297, 25, $WS_GROUP)
	GUICtrlCreateGroup("", -99, -99, 1, 1)
	$exportGroup = GUICtrlCreateGroup("Export", 8, 112, 313, 97)
	$PortableToFullButton = GUICtrlCreateButton("Portable to Full", 16, 128, 297, 25, $WS_GROUP)
	$portableToDemoAllUsersButton = GUICtrlCreateButton("Portable to Demo Public", 16, 152, 297, 25, $WS_GROUP)
	$portabletoDemoPersonalButton = GUICtrlCreateButton("Portable to Demo Private", 16, 176, 297, 25, $WS_GROUP)
	GUICtrlCreateGroup("", -99, -99, 1, 1)
	$xferGroup = GUICtrlCreateGroup("Transfer", 8, 216, 313, 169)
	$fullToDemoAllUsersButton = GUICtrlCreateButton("Full to Demo Public", 16, 232, 297, 25, $WS_GROUP)
	$fullToDemoPersonalButton = GUICtrlCreateButton("Full to Demo Private", 16, 256, 297, 25, $WS_GROUP)
	$demoAllUsersToFullButton = GUICtrlCreateButton("Demo Public to Full", 16, 280, 297, 25, $WS_GROUP)
	$demoAllUsersToDemoPersonalButton = GUICtrlCreateButton("Demo Public to Demo Private", 16, 304, 297, 25, $WS_GROUP)
	$demoPersonalToFullButton = GUICtrlCreateButton("Demo Private to Full", 16, 328, 297, 25, $WS_GROUP)
	$demoPersonalToDemoAllUsersButton = GUICtrlCreateButton("Demo Private to Demo Public", 16, 352, 297, 25, $WS_GROUP)
	GUICtrlCreateGroup("", -99, -99, 1, 1)
	$deleteGroup = GUICtrlCreateGroup("Delete", 8, 392, 313, 97)
	$deleteFullButton = GUICtrlCreateButton("Delete Full", 16, 408, 297, 25, $WS_GROUP)
	$deleteDemoAllUsersButton = GUICtrlCreateButton("Delete Demo Public", 16, 432, 297, 25, $WS_GROUP)
	$deleteDemoPersonalButton = GUICtrlCreateButton("Delete Demo Private", 16, 456, 297, 25, $WS_GROUP)
	GUICtrlCreateGroup("", -99, -99, 1, 1)
	$closeButton = GUICtrlCreateButton("Close", 232, 496, 89, 25, $WS_GROUP)
	GUISetState(@SW_SHOW)
	#EndRegion ### END Koda GUI section ###

	While 1
		$copyError = 2
		$nMsg = GUIGetMsg()
		Switch $nMsg
			Case $GUI_EVENT_CLOSE
				$copyError = 2
				GUIDelete($profileForm)
				ExitLoop
			Case $fullToPortableButton
				$copyError = copyProfile($2DBoyProfilePathFull & $WoGProfileFolder, $portableProfilePath)
			Case $demoAllUsersToPortableButton
				$copyError = copyProfile($2DBoyProfilePathDemoAllUsers & $WoGProfileFolder, $portableProfilePath)
			Case $demoPersonalToPortableButton
				$copyError = copyProfile($2DBoyProfilePathDemoPersonal & $WoGProfileFolder, $portableProfilePath)
			Case $PortableToFullButton
				$copyError = copyProfile($portableProfilePath, $2DBoyProfilePathFull & $WoGProfileFolder)
			Case $portableToDemoAllUsersButton
				$copyError = copyProfile($portableProfilePath, $2DBoyProfilePathDemoAllUsers & $WoGProfileFolder)
			Case $portabletoDemoPersonalButton
				$copyError = copyProfile($portableProfilePath, $2DBoyProfilePathDemoPersonal & $WoGProfileFolder)
			Case $fullToDemoAllUsersButton
				$copyError = copyProfile($2DBoyProfilePathFull & $WoGProfileFolder, $2DBoyProfilePathDemoAllUsers & $WoGProfileFolder)
			Case $fullToDemoPersonalButton
				$copyError = copyProfile($2DBoyProfilePathFull & $WoGProfileFolder, $2DBoyProfilePathDemoPersonal & $WoGProfileFolder)
			Case $demoAllUsersToFullButton
				$copyError = copyProfile($2DBoyProfilePathDemoAllUsers & $WoGProfileFolder, $2DBoyProfilePathFull & $WoGProfileFolder)
			Case $demoAllUsersToDemoPersonalButton
				$copyError = copyProfile($2DBoyProfilePathDemoAllUsers & $WoGProfileFolder, $2DBoyProfilePathDemoPersonal & $WoGProfileFolder)
			Case $demoPersonalToFullButton
				$copyError = copyProfile($2DBoyProfilePathDemoPersonal & $WoGProfileFolder, $2DBoyProfilePathFull & $WoGProfileFolder)
			Case $demoPersonalToDemoAllUsersButton
				$copyError = copyProfile($2DBoyProfilePathDemoPersonal & $WoGProfileFolder, $2DBoyProfilePathDemoAllUsers & $WoGProfileFolder)
			Case $deleteFullButton
				$copyError = FileDelete($2DBoyProfilePathFull & $WoGProfileFolder & "pers2.dat")
				If $copyError == 0 Then
					$copyError = 1
				ElseIf $copyError == 1 Then
					$copyError = 0
				EndIf
			Case $deleteDemoAllUsersButton
				$copyError = FileDelete($2DBoyProfilePathDemoAllUsers & $WoGProfileFolder & "pers2.dat")
				If $copyError == 0 Then
					$copyError = 1
				ElseIf $copyError == 1 Then
					$copyError = 0
				EndIf
			Case $deleteDemoPersonalButton
				$copyError = FileDelete($2DBoyProfilePathDemoPersonal & $WoGProfileFolder & "pers2.dat")
				If $copyError == 0 Then
					$copyError = 1
				ElseIf $copyError == 1 Then
					$copyError = 0
				EndIf
			Case $closeButton
				$copyError = 2
				GUIDelete($profileForm)
				ExitLoop
		EndSwitch
		If $copyError == 1 Then
			MsgBox(0x30, "World of Goo Portable", "Operation failed!")
		ElseIf $copyError == 0 Then
			MsgBox(0x40, "World of Goo Portable", "Operation succeeded!")
		EndIf
	WEnd
	$copyError = 0
EndFunc   ;==>openProfilesGUI

;Options Dialog GUI
Func openOptionsGUI()
	#Region ### START Koda GUI section ### Form=D:\Documents and Settings\Yukai\Desktop\wogportable\optionsForm.kxf
	$optionsForm = GUICreate("Options", 330, 276, -1, -1)
	$secondsInput = GUICtrlCreateInput("", 208, 8, 33, 21)
	GUICtrlSetState(-1, $GUI_DISABLE)
	$secondsLabel = GUICtrlCreateLabel("seconds", 248, 10, 44, 17)
	$autoLaunchCheckbox = GUICtrlCreateCheckbox("Automatically launch World of Goo in", 8, 8, 193, 17)
	GUICtrlSetState(-1, $GUI_DISABLE)
	$isDemoCheckbox = GUICtrlCreateCheckbox("World of Goo is using demo engine", 8, 32, 193, 17)
	If IniRead($cfgPath, "Main", "WoGType", "auto") == "demo" Then
		GUICtrlSetState($isDemoCheckbox, $GUI_CHECKED)
	EndIf
	$aboutGroup = GUICtrlCreateGroup("About", 8, 112, 313, 129)
	$WoGPortableLabel = GUICtrlCreateLabel("World of Goo Portable Launcher", 56, 128, 157, 17)
	$copyrightLabel = GUICtrlCreateLabel("2009 GMMan and GMWare. All Rights Reserved.", 56, 176, 247, 17)
	$supportButton = GUICtrlCreateButton("Support", 16, 201, 73, 25, $WS_GROUP)
	$versionLabel = GUICtrlCreateLabel("Version " & $version, 56, 152, 250, 17)
	$WoGPortableIcon = GUICtrlCreateIcon(@ScriptDir & "\cfg\WorldOfGoo.ico", -1, 16, 128, 32, 32, BitOR($SS_NOTIFY, $WS_GROUP))
	$licenseLabel = GUICtrlCreateLabel("Distributed under the Creative Commons Attribution-Share Alike 2.5 Canada License", 96, 200, 214, 25)
	GUICtrlCreateGroup("", -99, -99, 1, 1)
	$OKButton = GUICtrlCreateButton("OK", 174, 248, 73, 25, $WS_GROUP)
	$cancelButton = GUICtrlCreateButton("Cancel", 248, 248, 73, 25, $WS_GROUP)
	$dontCopyGooToolCheckbox = GUICtrlCreateCheckbox("Don't copy GooTool", 8, 56, 121, 17)
	If IniRead($cfgPath, "Main", "dontCopyGooTool", "auto") == 1 Then
		GUICtrlSetState($dontCopyGooToolCheckbox, $GUI_CHECKED)
	EndIf
	$CopyGooToolButton = GUICtrlCreateButton("Copy GooTool", 8, 80, 315, 25, $WS_GROUP)
	GUICtrlSetState($CopyGooToolButton, $GUI_DISABLE)
	If Not gooToolCopied() Then
		GUICtrlSetState($CopyGooToolButton, $GUI_ENABLE)
	EndIf
	GUISetState(@SW_SHOW)
	#EndRegion ### END Koda GUI section ###

	While 1
		$nMsg = GUIGetMsg()
		Switch $nMsg
			Case $GUI_EVENT_CLOSE
				GUIDelete($optionsForm)
				If gooToolCopied() And Not $usingMainGUIGooTool Then
					GUIDelete($mainGUIForm)
					openMainGUIGooTool()
				EndIf
				ExitLoop
			Case $supportButton
				ShellExecute("http://2dboy.com/forum/index.php/topic,2336.0.html")
			Case $OKButton
				;Write Demo Engine var
				$demoEngineCheckboxState = GUICtrlRead($isDemoCheckbox)
				If $demoEngineCheckboxState == $GUI_CHECKED Then
					$WoGType = "demo"
				ElseIf $demoEngineCheckboxState == $GUI_UNCHECKED Then
					$WoGType = "auto"
				EndIf
				;Write Don't Copy GooTool var
				$dontCopyGooToolState = GUICtrlRead($dontCopyGooToolCheckbox)
				If $dontCopyGooToolState == $GUI_CHECKED Then
					$dontCopyGooTool = 1
				ElseIf $dontCopyGooToolState == $GUI_UNCHECKED Then
					$dontCopyGooTool = 0
				EndIf
				IniWrite($cfgPath, "Main", "WoGType", $WoGType)
				IniWrite($cfgPath, "Main", "dontCopyGooTool", $dontCopyGooTool)
				GUIDelete($optionsForm)
				If gooToolCopied() And Not $usingMainGUIGooTool Then
					GUIDelete($mainGUIForm)
					openMainGUIGooTool()
				EndIf
				ExitLoop
			Case $cancelButton
				GUIDelete($optionsForm)
				If gooToolCopied() And Not $usingMainGUIGooTool Then
					GUIDelete($mainGUIForm)
					openMainGUIGooTool()
				EndIf
				ExitLoop
			Case $CopyGooToolButton
				;Architecture check
				If EnvGet("PROGRAMFILES(X86)") <> "" Then
					If FileExists($defaultGooToolInstallPathx64 & "bin\gootool.exe") Then
						$copyError = copyWoG($defaultGooToolInstallPathx64, "GooTool", 0)
					Else
						$copyError = 1
					EndIf
				Else
					If FileExists($defaultGooToolInstallPath & "bin\gootool.exe") Then
						$copyError = copyWoG($defaultGooToolInstallPath, "GooTool", 0)
					Else
						$copyError = 1
					EndIf
				EndIf
				checkCopyError("GooTool")
				If gooToolCopied() Then
					GUICtrlSetState($CopyGooToolButton, $GUI_DISABLE)
				EndIf
		EndSwitch
	WEnd
EndFunc   ;==>openOptionsGUI

;Information Superhighway GUI
Func openOnlineGUI()
	#Region ### START Koda GUI section ### Form=d:\documents and settings\yukai\desktop\wogportable\onlineform.kxf
	$onlineForm = GUICreate("Information Superhighway", 202, 242, -1, -1)
	$patchButton = GUICtrlCreateButton("World of Goo Patch", 8, 8, 185, 25, $WS_GROUP)
	$twodBoyButton = GUICtrlCreateButton("2D Boy", 8, 32, 185, 25, $WS_GROUP)
	$WoGSoundtrackButton = GUICtrlCreateButton("World of Goo Soundtrack", 8, 104, 185, 25, $WS_GROUP)
	$gooFansButton = GUICtrlCreateButton("GooFans", 8, 56, 185, 25, $WS_GROUP)
	$kyleGablerButton = GUICtrlCreateButton("Kyle Gabler's Website", 8, 128, 185, 25, $WS_GROUP)
	$twodBoyForumButton = GUICtrlCreateButton("2D Boy Forum", 8, 80, 185, 25, $WS_GROUP)
	$experimentalGameplayButton = GUICtrlCreateButton("Experimental Gameplay", 8, 152, 185, 25, $WS_GROUP)
	$WoGWikiButton = GUICtrlCreateButton("World of Goo Wiki on Wikia", 8, 176, 185, 25, $WS_GROUP)
	$closeButton = GUICtrlCreateButton("Close", 120, 208, 73, 25, $WS_GROUP)
	GUISetState(@SW_SHOW)
	#EndRegion ### END Koda GUI section ###

	While 1
		$nMsg = GUIGetMsg()
		Switch $nMsg
			Case $GUI_EVENT_CLOSE
				GUIDelete($onlineForm)
				ExitLoop
			Case $patchButton
				ShellExecute($WoGPatchURL)
			Case $twodBoyButton
				ShellExecute($twodBoyURL)
			Case $WoGSoundtrackButton
				ShellExecute($WoGSoundtrackURL)
			Case $gooFansButton
				ShellExecute($gooFansURL)
			Case $kyleGablerButton
				ShellExecute($kyleGablerURL)
			Case $twodBoyForumButton
				ShellExecute($twodBoyForumURL)
			Case $experimentalGameplayButton
				ShellExecute($experimentalGameplayURL)
			Case $WoGWikiButton
				ShellExecute($WoGWikiURL)
			Case $closeButton
				GUIDelete($onlineForm)
				ExitLoop
		EndSwitch
	WEnd
EndFunc   ;==>openOnlineGUI